/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _UNITYSHELL_OPTIONS_H
#define _UNITYSHELL_OPTIONS_H

#include <core/core.h>

class UnityshellOptions : public CompOption::Class {
    public:
        enum Options {
            LauncherRevealEdge,
            LauncherRevealEdgeTimeout,
            LauncherHideMode,
            ShowLauncher,
            KeyboardFocus,
            ExecuteCommand,
            PanelFirstMenu,
            AltTabTimeout,
            AltTabBiasViewport,
            AltTabForward,
            AltTabPrev,
            AltTabRight,
            AltTabLeft,
            AltTabDetailStart,
            AltTabDetailStop,
            AltTabNextWindow,
            AltTabPrevWindow,
            ShowMinimizedWindows,
            BacklightMode,
            LaunchAnimation,
            UrgentAnimation,
            PanelOpacity,
            LauncherOpacity,
            IconSize,
            AutohideAnimation,
            DashBlurExperimental,
            AutomaximizeValue,
            DevicesOption,
            OptionNum
        };

        enum LauncherHideMode {
            LauncherHideModeNever = 0,
            LauncherHideModeAutohide = 1,
            LauncherHideModeDodgeWindows = 2,
            LauncherHideModeDodgeActiveWindow = 3,
        };

        enum BacklightMode {
            BacklightModeBacklightAlwaysOn = 0,
            BacklightModeBacklightToggles = 1,
            BacklightModeBacklightAlwaysOff = 2,
            BacklightModeEdgeIlluminationToggles = 3,
            BacklightModeBacklightAndEdgeIlluminationToggles = 4,
        };

        enum LaunchAnimation {
            LaunchAnimationNone = 0,
            LaunchAnimationPulseUntilRunning = 1,
            LaunchAnimationBlink = 2,
        };

        enum UrgentAnimation {
            UrgentAnimationNone = 0,
            UrgentAnimationPulse = 1,
            UrgentAnimationWiggle = 2,
        };

        enum AutohideAnimation {
            AutohideAnimationFadeOnBfbAndSlide = 0,
            AutohideAnimationSlideOnly = 1,
            AutohideAnimationFadeOnly = 2,
            AutohideAnimationFadeAndSlide = 3,
        };

        enum DashBlurExperimental {
            DashBlurExperimentalNoBlur = 0,
            DashBlurExperimentalStaticBlur = 1,
            DashBlurExperimentalActiveBlur = 2,
        };

        enum DevicesOption {
            DevicesOptionNever = 0,
            DevicesOptionOnlyMounted = 1,
            DevicesOptionAlways = 2,
        };

        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        UnityshellOptions ();
        virtual ~UnityshellOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        CompAction & optionGetLauncherRevealEdge ();
        void optionSetLauncherRevealEdgeInitiate (CompAction::CallBack init);
        void optionSetLauncherRevealEdgeTerminate (CompAction::CallBack term);
        void optionSetLauncherRevealEdgeNotify (ChangeNotify notify);

        int optionGetLauncherRevealEdgeTimeout ();
        void optionSetLauncherRevealEdgeTimeoutNotify (ChangeNotify notify);

        int optionGetLauncherHideMode ();
        void optionSetLauncherHideModeNotify (ChangeNotify notify);

        CompAction & optionGetShowLauncher ();
        void optionSetShowLauncherInitiate (CompAction::CallBack init);
        void optionSetShowLauncherTerminate (CompAction::CallBack term);
        void optionSetShowLauncherNotify (ChangeNotify notify);

        CompAction & optionGetKeyboardFocus ();
        void optionSetKeyboardFocusInitiate (CompAction::CallBack init);
        void optionSetKeyboardFocusTerminate (CompAction::CallBack term);
        void optionSetKeyboardFocusNotify (ChangeNotify notify);

        CompAction & optionGetExecuteCommand ();
        void optionSetExecuteCommandInitiate (CompAction::CallBack init);
        void optionSetExecuteCommandTerminate (CompAction::CallBack term);
        void optionSetExecuteCommandNotify (ChangeNotify notify);

        CompAction & optionGetPanelFirstMenu ();
        void optionSetPanelFirstMenuInitiate (CompAction::CallBack init);
        void optionSetPanelFirstMenuTerminate (CompAction::CallBack term);
        void optionSetPanelFirstMenuNotify (ChangeNotify notify);

        bool optionGetAltTabTimeout ();
        void optionSetAltTabTimeoutNotify (ChangeNotify notify);

        bool optionGetAltTabBiasViewport ();
        void optionSetAltTabBiasViewportNotify (ChangeNotify notify);

        CompAction & optionGetAltTabForward ();
        void optionSetAltTabForwardInitiate (CompAction::CallBack init);
        void optionSetAltTabForwardTerminate (CompAction::CallBack term);
        void optionSetAltTabForwardNotify (ChangeNotify notify);

        CompAction & optionGetAltTabPrev ();
        void optionSetAltTabPrevInitiate (CompAction::CallBack init);
        void optionSetAltTabPrevTerminate (CompAction::CallBack term);
        void optionSetAltTabPrevNotify (ChangeNotify notify);

        CompAction & optionGetAltTabRight ();
        void optionSetAltTabRightInitiate (CompAction::CallBack init);
        void optionSetAltTabRightTerminate (CompAction::CallBack term);
        void optionSetAltTabRightNotify (ChangeNotify notify);

        CompAction & optionGetAltTabLeft ();
        void optionSetAltTabLeftInitiate (CompAction::CallBack init);
        void optionSetAltTabLeftTerminate (CompAction::CallBack term);
        void optionSetAltTabLeftNotify (ChangeNotify notify);

        CompAction & optionGetAltTabDetailStart ();
        void optionSetAltTabDetailStartInitiate (CompAction::CallBack init);
        void optionSetAltTabDetailStartTerminate (CompAction::CallBack term);
        void optionSetAltTabDetailStartNotify (ChangeNotify notify);

        CompAction & optionGetAltTabDetailStop ();
        void optionSetAltTabDetailStopInitiate (CompAction::CallBack init);
        void optionSetAltTabDetailStopTerminate (CompAction::CallBack term);
        void optionSetAltTabDetailStopNotify (ChangeNotify notify);

        CompAction & optionGetAltTabNextWindow ();
        void optionSetAltTabNextWindowInitiate (CompAction::CallBack init);
        void optionSetAltTabNextWindowTerminate (CompAction::CallBack term);
        void optionSetAltTabNextWindowNotify (ChangeNotify notify);

        CompAction & optionGetAltTabPrevWindow ();
        void optionSetAltTabPrevWindowInitiate (CompAction::CallBack init);
        void optionSetAltTabPrevWindowTerminate (CompAction::CallBack term);
        void optionSetAltTabPrevWindowNotify (ChangeNotify notify);

        bool optionGetShowMinimizedWindows ();
        void optionSetShowMinimizedWindowsNotify (ChangeNotify notify);

        int optionGetBacklightMode ();
        void optionSetBacklightModeNotify (ChangeNotify notify);

        int optionGetLaunchAnimation ();
        void optionSetLaunchAnimationNotify (ChangeNotify notify);

        int optionGetUrgentAnimation ();
        void optionSetUrgentAnimationNotify (ChangeNotify notify);

        float optionGetPanelOpacity ();
        void optionSetPanelOpacityNotify (ChangeNotify notify);

        float optionGetLauncherOpacity ();
        void optionSetLauncherOpacityNotify (ChangeNotify notify);

        int optionGetIconSize ();
        void optionSetIconSizeNotify (ChangeNotify notify);

        int optionGetAutohideAnimation ();
        void optionSetAutohideAnimationNotify (ChangeNotify notify);

        int optionGetDashBlurExperimental ();
        void optionSetDashBlurExperimentalNotify (ChangeNotify notify);

        int optionGetAutomaximizeValue ();
        void optionSetAutomaximizeValueNotify (ChangeNotify notify);

        int optionGetDevicesOption ();
        void optionSetDevicesOptionNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;

};


inline CompAction &
UnityshellOptions::optionGetLauncherRevealEdge ()
{
    return mOptions[UnityshellOptions::LauncherRevealEdge].value ().action ();
}

inline void
UnityshellOptions::optionSetLauncherRevealEdgeInitiate (CompAction::CallBack init)
{
    mOptions[UnityshellOptions::LauncherRevealEdge].value ().action ().setInitiate (init);
}

inline void
UnityshellOptions::optionSetLauncherRevealEdgeTerminate (CompAction::CallBack term)
{
    mOptions[UnityshellOptions::LauncherRevealEdge].value ().action ().setTerminate (term);
}

inline void
UnityshellOptions::optionSetLauncherRevealEdgeNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::LauncherRevealEdge] = notify;
}

inline int
UnityshellOptions::optionGetLauncherRevealEdgeTimeout ()
{
    return mOptions[UnityshellOptions::LauncherRevealEdgeTimeout].value ().i ();
}

inline void
UnityshellOptions::optionSetLauncherRevealEdgeTimeoutNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::LauncherRevealEdgeTimeout] = notify;
}

inline int
UnityshellOptions::optionGetLauncherHideMode ()
{
    return mOptions[UnityshellOptions::LauncherHideMode].value ().i ();
}

inline void
UnityshellOptions::optionSetLauncherHideModeNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::LauncherHideMode] = notify;
}

inline CompAction &
UnityshellOptions::optionGetShowLauncher ()
{
    return mOptions[UnityshellOptions::ShowLauncher].value ().action ();
}

inline void
UnityshellOptions::optionSetShowLauncherInitiate (CompAction::CallBack init)
{
    mOptions[UnityshellOptions::ShowLauncher].value ().action ().setInitiate (init);
}

inline void
UnityshellOptions::optionSetShowLauncherTerminate (CompAction::CallBack term)
{
    mOptions[UnityshellOptions::ShowLauncher].value ().action ().setTerminate (term);
}

inline void
UnityshellOptions::optionSetShowLauncherNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::ShowLauncher] = notify;
}

inline CompAction &
UnityshellOptions::optionGetKeyboardFocus ()
{
    return mOptions[UnityshellOptions::KeyboardFocus].value ().action ();
}

inline void
UnityshellOptions::optionSetKeyboardFocusInitiate (CompAction::CallBack init)
{
    mOptions[UnityshellOptions::KeyboardFocus].value ().action ().setInitiate (init);
}

inline void
UnityshellOptions::optionSetKeyboardFocusTerminate (CompAction::CallBack term)
{
    mOptions[UnityshellOptions::KeyboardFocus].value ().action ().setTerminate (term);
}

inline void
UnityshellOptions::optionSetKeyboardFocusNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::KeyboardFocus] = notify;
}

inline CompAction &
UnityshellOptions::optionGetExecuteCommand ()
{
    return mOptions[UnityshellOptions::ExecuteCommand].value ().action ();
}

inline void
UnityshellOptions::optionSetExecuteCommandInitiate (CompAction::CallBack init)
{
    mOptions[UnityshellOptions::ExecuteCommand].value ().action ().setInitiate (init);
}

inline void
UnityshellOptions::optionSetExecuteCommandTerminate (CompAction::CallBack term)
{
    mOptions[UnityshellOptions::ExecuteCommand].value ().action ().setTerminate (term);
}

inline void
UnityshellOptions::optionSetExecuteCommandNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::ExecuteCommand] = notify;
}

inline CompAction &
UnityshellOptions::optionGetPanelFirstMenu ()
{
    return mOptions[UnityshellOptions::PanelFirstMenu].value ().action ();
}

inline void
UnityshellOptions::optionSetPanelFirstMenuInitiate (CompAction::CallBack init)
{
    mOptions[UnityshellOptions::PanelFirstMenu].value ().action ().setInitiate (init);
}

inline void
UnityshellOptions::optionSetPanelFirstMenuTerminate (CompAction::CallBack term)
{
    mOptions[UnityshellOptions::PanelFirstMenu].value ().action ().setTerminate (term);
}

inline void
UnityshellOptions::optionSetPanelFirstMenuNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::PanelFirstMenu] = notify;
}

inline bool
UnityshellOptions::optionGetAltTabTimeout ()
{
    return mOptions[UnityshellOptions::AltTabTimeout].value ().b ();
}

inline void
UnityshellOptions::optionSetAltTabTimeoutNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::AltTabTimeout] = notify;
}

inline bool
UnityshellOptions::optionGetAltTabBiasViewport ()
{
    return mOptions[UnityshellOptions::AltTabBiasViewport].value ().b ();
}

inline void
UnityshellOptions::optionSetAltTabBiasViewportNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::AltTabBiasViewport] = notify;
}

inline CompAction &
UnityshellOptions::optionGetAltTabForward ()
{
    return mOptions[UnityshellOptions::AltTabForward].value ().action ();
}

inline void
UnityshellOptions::optionSetAltTabForwardInitiate (CompAction::CallBack init)
{
    mOptions[UnityshellOptions::AltTabForward].value ().action ().setInitiate (init);
}

inline void
UnityshellOptions::optionSetAltTabForwardTerminate (CompAction::CallBack term)
{
    mOptions[UnityshellOptions::AltTabForward].value ().action ().setTerminate (term);
}

inline void
UnityshellOptions::optionSetAltTabForwardNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::AltTabForward] = notify;
}

inline CompAction &
UnityshellOptions::optionGetAltTabPrev ()
{
    return mOptions[UnityshellOptions::AltTabPrev].value ().action ();
}

inline void
UnityshellOptions::optionSetAltTabPrevInitiate (CompAction::CallBack init)
{
    mOptions[UnityshellOptions::AltTabPrev].value ().action ().setInitiate (init);
}

inline void
UnityshellOptions::optionSetAltTabPrevTerminate (CompAction::CallBack term)
{
    mOptions[UnityshellOptions::AltTabPrev].value ().action ().setTerminate (term);
}

inline void
UnityshellOptions::optionSetAltTabPrevNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::AltTabPrev] = notify;
}

inline CompAction &
UnityshellOptions::optionGetAltTabRight ()
{
    return mOptions[UnityshellOptions::AltTabRight].value ().action ();
}

inline void
UnityshellOptions::optionSetAltTabRightInitiate (CompAction::CallBack init)
{
    mOptions[UnityshellOptions::AltTabRight].value ().action ().setInitiate (init);
}

inline void
UnityshellOptions::optionSetAltTabRightTerminate (CompAction::CallBack term)
{
    mOptions[UnityshellOptions::AltTabRight].value ().action ().setTerminate (term);
}

inline void
UnityshellOptions::optionSetAltTabRightNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::AltTabRight] = notify;
}

inline CompAction &
UnityshellOptions::optionGetAltTabLeft ()
{
    return mOptions[UnityshellOptions::AltTabLeft].value ().action ();
}

inline void
UnityshellOptions::optionSetAltTabLeftInitiate (CompAction::CallBack init)
{
    mOptions[UnityshellOptions::AltTabLeft].value ().action ().setInitiate (init);
}

inline void
UnityshellOptions::optionSetAltTabLeftTerminate (CompAction::CallBack term)
{
    mOptions[UnityshellOptions::AltTabLeft].value ().action ().setTerminate (term);
}

inline void
UnityshellOptions::optionSetAltTabLeftNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::AltTabLeft] = notify;
}

inline CompAction &
UnityshellOptions::optionGetAltTabDetailStart ()
{
    return mOptions[UnityshellOptions::AltTabDetailStart].value ().action ();
}

inline void
UnityshellOptions::optionSetAltTabDetailStartInitiate (CompAction::CallBack init)
{
    mOptions[UnityshellOptions::AltTabDetailStart].value ().action ().setInitiate (init);
}

inline void
UnityshellOptions::optionSetAltTabDetailStartTerminate (CompAction::CallBack term)
{
    mOptions[UnityshellOptions::AltTabDetailStart].value ().action ().setTerminate (term);
}

inline void
UnityshellOptions::optionSetAltTabDetailStartNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::AltTabDetailStart] = notify;
}

inline CompAction &
UnityshellOptions::optionGetAltTabDetailStop ()
{
    return mOptions[UnityshellOptions::AltTabDetailStop].value ().action ();
}

inline void
UnityshellOptions::optionSetAltTabDetailStopInitiate (CompAction::CallBack init)
{
    mOptions[UnityshellOptions::AltTabDetailStop].value ().action ().setInitiate (init);
}

inline void
UnityshellOptions::optionSetAltTabDetailStopTerminate (CompAction::CallBack term)
{
    mOptions[UnityshellOptions::AltTabDetailStop].value ().action ().setTerminate (term);
}

inline void
UnityshellOptions::optionSetAltTabDetailStopNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::AltTabDetailStop] = notify;
}

inline CompAction &
UnityshellOptions::optionGetAltTabNextWindow ()
{
    return mOptions[UnityshellOptions::AltTabNextWindow].value ().action ();
}

inline void
UnityshellOptions::optionSetAltTabNextWindowInitiate (CompAction::CallBack init)
{
    mOptions[UnityshellOptions::AltTabNextWindow].value ().action ().setInitiate (init);
}

inline void
UnityshellOptions::optionSetAltTabNextWindowTerminate (CompAction::CallBack term)
{
    mOptions[UnityshellOptions::AltTabNextWindow].value ().action ().setTerminate (term);
}

inline void
UnityshellOptions::optionSetAltTabNextWindowNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::AltTabNextWindow] = notify;
}

inline CompAction &
UnityshellOptions::optionGetAltTabPrevWindow ()
{
    return mOptions[UnityshellOptions::AltTabPrevWindow].value ().action ();
}

inline void
UnityshellOptions::optionSetAltTabPrevWindowInitiate (CompAction::CallBack init)
{
    mOptions[UnityshellOptions::AltTabPrevWindow].value ().action ().setInitiate (init);
}

inline void
UnityshellOptions::optionSetAltTabPrevWindowTerminate (CompAction::CallBack term)
{
    mOptions[UnityshellOptions::AltTabPrevWindow].value ().action ().setTerminate (term);
}

inline void
UnityshellOptions::optionSetAltTabPrevWindowNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::AltTabPrevWindow] = notify;
}

inline bool
UnityshellOptions::optionGetShowMinimizedWindows ()
{
    return mOptions[UnityshellOptions::ShowMinimizedWindows].value ().b ();
}

inline void
UnityshellOptions::optionSetShowMinimizedWindowsNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::ShowMinimizedWindows] = notify;
}

inline int
UnityshellOptions::optionGetBacklightMode ()
{
    return mOptions[UnityshellOptions::BacklightMode].value ().i ();
}

inline void
UnityshellOptions::optionSetBacklightModeNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::BacklightMode] = notify;
}

inline int
UnityshellOptions::optionGetLaunchAnimation ()
{
    return mOptions[UnityshellOptions::LaunchAnimation].value ().i ();
}

inline void
UnityshellOptions::optionSetLaunchAnimationNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::LaunchAnimation] = notify;
}

inline int
UnityshellOptions::optionGetUrgentAnimation ()
{
    return mOptions[UnityshellOptions::UrgentAnimation].value ().i ();
}

inline void
UnityshellOptions::optionSetUrgentAnimationNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::UrgentAnimation] = notify;
}

inline float
UnityshellOptions::optionGetPanelOpacity ()
{
    return mOptions[UnityshellOptions::PanelOpacity].value ().f ();
}

inline void
UnityshellOptions::optionSetPanelOpacityNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::PanelOpacity] = notify;
}

inline float
UnityshellOptions::optionGetLauncherOpacity ()
{
    return mOptions[UnityshellOptions::LauncherOpacity].value ().f ();
}

inline void
UnityshellOptions::optionSetLauncherOpacityNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::LauncherOpacity] = notify;
}

inline int
UnityshellOptions::optionGetIconSize ()
{
    return mOptions[UnityshellOptions::IconSize].value ().i ();
}

inline void
UnityshellOptions::optionSetIconSizeNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::IconSize] = notify;
}

inline int
UnityshellOptions::optionGetAutohideAnimation ()
{
    return mOptions[UnityshellOptions::AutohideAnimation].value ().i ();
}

inline void
UnityshellOptions::optionSetAutohideAnimationNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::AutohideAnimation] = notify;
}

inline int
UnityshellOptions::optionGetDashBlurExperimental ()
{
    return mOptions[UnityshellOptions::DashBlurExperimental].value ().i ();
}

inline void
UnityshellOptions::optionSetDashBlurExperimentalNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::DashBlurExperimental] = notify;
}

inline int
UnityshellOptions::optionGetAutomaximizeValue ()
{
    return mOptions[UnityshellOptions::AutomaximizeValue].value ().i ();
}

inline void
UnityshellOptions::optionSetAutomaximizeValueNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::AutomaximizeValue] = notify;
}

inline int
UnityshellOptions::optionGetDevicesOption ()
{
    return mOptions[UnityshellOptions::DevicesOption].value ().i ();
}

inline void
UnityshellOptions::optionSetDevicesOptionNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::DevicesOption] = notify;
}



#endif
